/********************************************************************************/
/*!
	@file			platform_config.h
	@author         Nemui Trinomius (http://nemuisan.blog.bai.ne.jp)
    @version        1.00
    @date           2011.06.12
	@brief          Based on ST Microelectronics's Sample Thanks!

    @section HISTORY
		2011.06.12	V1.00	Start Here.

    @section LICENSE
		BSD License. See Copyright.txt
*/
/********************************************************************************/
#ifndef __PLATFORM_CONFIG_H
#define __PLATFORM_CONFIG_H 0x0100

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx.h"

/* Exported types ------------------------------------------------------------*/
#if defined(USE_REDBULL)
/* RED BULL Key Inputs */
#define KEY_PORT_USER1				(GPIOA)
#define KEY_PORT_USER2				(GPIOD)
#define KEY_PORT_TAMPER				(GPIOC)
#define KEY_PORT_WAKEUP				(GPIOA)

#define KEY_CLK_USER1				(RCC_AHB1Periph_GPIOA)
#define KEY_CLK_USER2				(RCC_AHB1Periph_GPIOD)
#define KEY_CLK_TAMPER				(RCC_AHB1Periph_GPIOC)
#define KEY_CLK_WAKEUP				(RCC_AHB1Periph_GPIOA)

#define K_USER1		       			(GPIO_Pin_8)
#define K_USER2       				(GPIO_Pin_3)
#define K_TAMPER		       		(GPIO_Pin_13)
#define K_WAKEUP       				(GPIO_Pin_0)

#define K_USER1_SFT					7
#define K_USER2_SFT					1
#define K_TAMPER_SFT				10
#define K_WAKEUP_SFT				0

#define KEY_U		       			(1<<2)	/* K_USER2 */
#define KEY_D       				(1<<1)	/* K_USER1 */		
#define KEY_R		       			(1<<3)	/* K_TAMPER */
#define KEY_L       				(1<<0)	/* K_WAKEUP */
#endif

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

#ifdef __cplusplus
}
#endif

#endif	/* __PLATFORM_CONFIG_H */
